VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmMain 
   AutoRedraw      =   -1  'True
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Diagramm"
   ClientHeight    =   5490
   ClientLeft      =   270
   ClientTop       =   1860
   ClientWidth     =   11880
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   366
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   792
   StartUpPosition =   1  'CenterOwner
   WindowState     =   2  'Maximized
   Begin VB.TextBox txtScales 
      Enabled         =   0   'False
      Height          =   285
      Left            =   10680
      TabIndex        =   11
      Text            =   "20"
      Top             =   120
      Width           =   1215
   End
   Begin VB.TextBox txtMaxValue 
      Enabled         =   0   'False
      Height          =   285
      Left            =   7920
      TabIndex        =   9
      Text            =   "250000"
      Top             =   120
      Width           =   1215
   End
   Begin VB.CheckBox chkAutoScale 
      Caption         =   "&Automatische Skalierung"
      Height          =   375
      Left            =   5640
      TabIndex        =   7
      Top             =   120
      Value           =   1  'Checked
      Width           =   1335
   End
   Begin VB.CommandButton cmdEnd 
      Cancel          =   -1  'True
      Caption         =   "&Ende"
      Height          =   255
      Left            =   4320
      TabIndex        =   6
      Top             =   120
      Width           =   1215
   End
   Begin VB.PictureBox picDiagramm 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H80000005&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   495
      Left            =   0
      ScaleHeight     =   33
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   81
      TabIndex        =   5
      Top             =   600
      Width           =   1215
   End
   Begin MSComDlg.CommonDialog dlgColor 
      Left            =   3720
      Top             =   2280
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.CommandButton cmdStart 
      Caption         =   "&Start"
      Default         =   -1  'True
      Height          =   255
      Left            =   3000
      TabIndex        =   4
      Top             =   120
      Width           =   1215
   End
   Begin VB.CommandButton cmdColorScale 
      BackColor       =   &H000000FF&
      Caption         =   "..."
      Height          =   255
      Left            =   2520
      Style           =   1  'Graphical
      TabIndex        =   3
      Top             =   120
      Width           =   375
   End
   Begin VB.CommandButton cmdColorLine 
      BackColor       =   &H00FF0000&
      Caption         =   "..."
      Height          =   255
      Left            =   1080
      Style           =   1  'Graphical
      TabIndex        =   1
      Top             =   120
      Width           =   375
   End
   Begin VB.Label Label4 
      AutoSize        =   -1  'True
      Caption         =   "Skalierungsschritte:"
      Height          =   195
      Left            =   9240
      TabIndex        =   10
      Top             =   120
      Width           =   1380
   End
   Begin VB.Label Label3 
      AutoSize        =   -1  'True
      Caption         =   "Max. Wert:"
      Height          =   195
      Left            =   7080
      TabIndex        =   8
      Top             =   120
      Width           =   780
   End
   Begin VB.Label Label2 
      AutoSize        =   -1  'True
      Caption         =   "Farbe Skala:"
      Height          =   195
      Left            =   1560
      TabIndex        =   2
      Top             =   120
      Width           =   900
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Farbe Linie:"
      Height          =   195
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   825
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'
' Modul: frmMain
'
' Author: Christoph Friedrich
' Letzte nderung: 20.02.2004
'

'Daten schon geladen: ja/nein
Public LoadData As Boolean

'
' Ereignis chkAutoScale_Click
'
' Author: Christoph Friedrich
'
' Beschreibung:
' Macht die Felder fr die manuelle Skalierung editierbar
'
Private Sub chkAutoScale_Click()
    If chkAutoScale.Value = 0 Then
        txtScales.Enabled = True
        txtMaxValue.Enabled = True
    Else
        txtScales.Enabled = False
        txtMaxValue.Enabled = False
    End If
End Sub

'
' Ereignis cmdColorLine_Click
'
' Author: Christoph Friedrich
'
' Beschreibung:
' Anzeige des ColorDialogs zur Auswahl der Farbe fr die Linie
'
Private Sub cmdColorLine_Click()
    dlgColor.Color = cmdColorLine.BackColor
    dlgColor.ShowColor
    cmdColorLine.BackColor = dlgColor.Color
End Sub

'
' Ereignis cmdColorScale_Click
'
' Author: Christoph Friedrich
'
' Beschreibung:
' Anzeige des ColorDialogs zur Auswahl der Farbe fr die
' Zahlen der Skalierung
'
Private Sub cmdColorScale_Click()
    dlgColor.Color = cmdColorScale.BackColor
    dlgColor.ShowColor
    cmdColorScale.BackColor = dlgColor.Color
End Sub

'
' Ereignis cmdEnd_Click
'
' Author: Christoph Friedrich
'
' Beschreibung:
' Beenden des Programms
'
Private Sub cmdEnd_Click()
    End
End Sub

'
' Ereignis cmdStart_Click
'
' Author: Christoph Friedrich
'
' Beschreibung:
' Ldt die Daten und startet die Anzeige
'
Private Sub cmdStart_Click()
    If LoadYesterdayData() And LoadTodayData() Then
        LoadData = True
        DrawGrid
    End If
End Sub

'
' Ereignis Form_Resize
'
' Author: Christoph Friedrich
'
' Beschreibung:
' ndern der Gre der PictureBox wenn sich die Fenstergre
' ndert
'
Private Sub Form_Resize()
    picDiagramm.Height = Me.ScaleHeight
    picDiagramm.Width = Me.ScaleWidth
    frmMain.WindowState = 2
    If LoadData Then DrawGrid
End Sub

'
' Funktion DrawGrid
'
' Author: Christoph Friedrich
'
' Zeichnet die Linien fr das Diagramm
'
Private Sub DrawGrid()
    Dim Left As Long    'Ecke links unten (X Wert)
    Dim Bottom As Long  'Ecke links unten (Y Wert)
    
    'PictureBox leeren
    picDiagramm.Cls
    
    'Berechnen der Eck-Koordinaten
    Left = 2 * picDiagramm.TextWidth(" " + Str$(GetMaxValue()))
    Bottom = picDiagramm.Height - (5 * picDiagramm.TextHeight("T"))
    
    'Zeichnen der Linien
    picDiagramm.Line (Left, picDiagramm.TextHeight("T"))-(Left, Bottom), vbBlack
    picDiagramm.Line (Left, Bottom)-(picDiagramm.Width - picDiagramm.TextWidth("TT"), Bottom), vbBlack
    
    'Aufrufen der Funktion zum Zeichnen der Skalierung
    Call DrawScale(Left, Bottom)
End Sub

Private Sub DrawScale(Left As Long, Bottom As Long)
    Dim TimeCount As Single     'Abstand zw. den Zeiten
    Dim ValueCount As Single    'Abstand zw. den Werten
    Dim MaxValue As Long        'Grte Wert
    Dim i As Single             'Zhlvariable
    Dim GMaxValue As Single     'Ergebnis der Funktion GetMaxValue
    Dim Scales As Integer       'Anzahl der Skalierungen
    
    'Prfen ob AutoScale angeschaltet ist
    If chkAutoScale.Value = 0 Then
        GMaxValue = txtMaxValue
        Scales = txtScales
    Else
        GMaxValue = GetMaxValue()
        Scales = 20
    End If
    
    'Berechnen der Abstnde zw. den Zeiten
    TimeCount = (picDiagramm.Width - picDiagramm.TextWidth("TT") - Left) / 24
    
    'Grter anzeigbarer Wert (meistens grer als GetMaxValue)
    MaxValue = Int((GMaxValue / (GMaxValue / 20))) * (GMaxValue / 20)
    
    'Berechnen der Abstnde zw. den Werten
    ValueCount = (Bottom - picDiagramm.TextHeight("T")) / MaxValue
        
    'Vordergrundfarbe setzen (= Farbe fr die Skalierung)
    picDiagramm.ForeColor = cmdColorScale.BackColor
    
    'Zeitenskalierung zeichnen
    For i = 0 To 24 Step 0.25
        picDiagramm.Line (Left + TimeCount * i, Bottom - 3)-(Left + TimeCount * i, Bottom + 3), vbBlack
        
        'Wenn volle Stunden gezeichnet werden
        If Int(i) = i Then
            'Grere Linie Zeichnen
            picDiagramm.Line (Left + TimeCount * i, Bottom - 6)-(Left + TimeCount * i, Bottom + 6), vbBlack
            
            'Nur alle 2 Stunden eine Zahl hinschreiben
            If i Mod 2 = 0 Then
                picDiagramm.CurrentX = Left + (TimeCount * i - picDiagramm.TextWidth(Trim$(Str$(24 - i))) / 2) - 3
                picDiagramm.CurrentY = Bottom + 8
                picDiagramm.Print 24 - i
            End If
        End If
    Next i
    
    'Werteskalierung zeichnen
    For i = 0 To MaxValue Step (GMaxValue / Scales)
        picDiagramm.Line (Left - 3, Bottom - i * ValueCount)-(Left + 3, Bottom - i * ValueCount), vbBlack
        
        'Alle zwei Striche eine Zahl hinschreiben (und eine
        'grere Linie)
        If (i Mod (GMaxValue / (Scales / 2))) = 0 Then
            picDiagramm.Line (Left - 6, Bottom - i * ValueCount)-(Left + 6, Bottom - i * ValueCount), vbBlack
            picDiagramm.CurrentX = Left - TextWidth(Str$(i)) - 8
            picDiagramm.CurrentY = Bottom - i * ValueCount - 5
            picDiagramm.Print i
        End If
    Next i
    
    'Funktion zum zeichnen der Linie aufrufen
    DrawLine Left, Bottom, TimeCount, ValueCount, MaxValue
End Sub

Private Sub DrawLine(Left As Long, Bottom As Long, TimeCount As Single, ValueCount As Single, MaxValue As Long)
    Dim StartTime As String         'Zeit ab der die Linie
                                    'gezeichnet werden soll
    Dim TimeDiff As Boolean         'Zeitdifferenz
                                    'grer als 15 Min.?
    Dim StartMin As Integer         'Aktuelle Minute
    Dim BigTimeDiff As Boolean      'Grere Zeitdiff.?
    
    Dim Time As Integer             'Aktueller Zeitabschnitt
    Dim ArrayPos As Integer         'Position im Array
    Dim AtYesterday As Boolean      'Noch bei gestrigen
                                    'Werten?
    Dim X As Single                 'X-Wert (Zeit)
    Dim Y As Single                 'Y-Wert (Wert)
    
    Dim OldX As Single              '
    Dim OldY As Single              '
    Dim OldArrayPos As Integer      'Werte des letzten Durchgangs
    Dim OldAtYesterday As Boolean   '
    Dim OldTime As Integer          '
    
    AtYesterday = True              'Immer Gestern beginnen
    BigTimeDiff = False
        
    'Berechnen der Startzeit anhand der aktuellen Minute
    StartMin = Val(Format(Now, "nn"))
    Select Case StartMin
        Case Is < 15
            StartTime = Format(Now, "hh:") + "00"
        Case Is < 30
            StartTime = Format(Now, "hh:") + "15"
        Case Is < 45
            StartTime = Format(Now, "hh:") + "30"
        Case Else
            StartTime = Format(Now, "hh:") + "45"
    End Select
    
    'Suchen der Position der Startzeit im Array Yesterday
    For i = 1 To 96
        If Yesterday(i).TimePoint = StartTime Then
            ArrayPos = i
            Exit For
        End If
    Next i
    
    'Immer beim ersten Zeit-Tick beginnen
    Time = 1
    
    Do
        'Koordinaten berechnen
        X = TimeCount * (Time / 4) + Left - (TimeCount / 4)
        If AtYesterday Then
            Y = Bottom - (Bottom - picDiagramm.TextHeight("T")) * Yesterday(ArrayPos).Value / MaxValue
        Else
            Y = Bottom - (Bottom - picDiagramm.TextHeight("T")) * Today(ArrayPos).Value / MaxValue
        End If
        
        'Nicht beim erstenmal gleich eine Linie zeichnen
        If Time > 1 Then
            'Prfen ob die Differenz zwischen den Zeiten
            'grer als eine Viertelstunde ist
            If AtYesterday Then
                TimeDiff = CheckTimeDiff(Yesterday(OldArrayPos).TimePoint, Yesterday(ArrayPos).TimePoint, False)
            Else
                If OldAtYesterday Then
                    TimeDiff = CheckTimeDiff(Yesterday(OldArrayPos).TimePoint, Today(ArrayPos).TimePoint, True)
                Else
                    TimeDiff = CheckTimeDiff(Today(OldArrayPos).TimePoint, Today(ArrayPos).TimePoint, True)
                End If
            End If
                                     
            If TimeDiff Then
                'Nur zeichnen wenn beim vorherigen Durchlauf
                'keine Differenz grer 15 Minuten
                'festgestellt wurde
                If Not BigTimeDiff Then picDiagramm.Line (OldX, OldY)-(X, Y), cmdColorLine.BackColor
                BigTimeDiff = False
            Else
                'Bei grerer Zeitdifferenz zum nchsten verfgbaren
                'Zeit-Tick springen
                If AtYesterday Then
                    Time = Time + GenTimeDiff(Yesterday(OldArrayPos).TimePoint, Yesterday(ArrayPos).TimePoint, False, False) - 1
                Else
                    If OldAtYesterday Then
                        Time = Time + GenTimeDiff(Yesterday(OldArrayPos).TimePoint, Today(ArrayPos).TimePoint, False, True) - 1
                    Else
                        Time = Time + GenTimeDiff(Today(OldArrayPos).TimePoint, Today(ArrayPos).TimePoint, True, True) - 1
                    End If
                End If
                BigTimeDiff = True
            End If
        End If
        
        'Daten des aktuellen Durchlaufes sichern
        OldX = X
        OldY = Y
        OldArrayPos = ArrayPos
        OldAtYesterday = AtYesterday
        OldTime = Time
             
        'Position im Array um 1 erhhen
        ArrayPos = ArrayPos + 1
        
        'Wenn an nchster Arrayposition kein Wert vorhanden
        'dann auf nchsten Tag wechseln
        If Yesterday(ArrayPos).TimePoint = "" Then
            ArrayPos = 1
            AtYesterday = False
        End If
        
        'Arraygrenzen nicht berschreiten
        If ArrayPos > 96 Then
            AtYesterday = False
            ArrayPos = 1
        End If
        
        'Nchster Zeit-Tick
        Time = Time + 1
        
    'Nur 98 Zeit-Ticks bearbeite
    Loop Until Time = 98
End Sub
