VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "LinienDiagramm"
   ClientHeight    =   10485
   ClientLeft      =   165
   ClientTop       =   450
   ClientWidth     =   17145
   LinkTopic       =   "Form1"
   ScaleHeight     =   10485
   ScaleWidth      =   17145
   StartUpPosition =   2  'Bildschirmmitte
   Begin VB.PictureBox picContainer 
      Appearance      =   0  '2D
      BackColor       =   &H00C0C0C0&
      ForeColor       =   &H80000008&
      Height          =   10095
      Left            =   60
      ScaleHeight     =   10065
      ScaleWidth      =   17025
      TabIndex        =   0
      Top             =   0
      Width           =   17055
      Begin VB.PictureBox picData 
         Appearance      =   0  '2D
         AutoRedraw      =   -1  'True
         BackColor       =   &H80000005&
         BeginProperty Font 
            Name            =   "Tahoma"
            Size            =   8.25
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         ForeColor       =   &H80000008&
         Height          =   10035
         Left            =   60
         ScaleHeight     =   10005
         ScaleWidth      =   17025
         TabIndex        =   2
         Top             =   60
         Width           =   17055
      End
   End
   Begin VB.HScrollBar sH 
      Height          =   255
      LargeChange     =   1000
      Left            =   60
      SmallChange     =   500
      TabIndex        =   1
      Top             =   10080
      Width           =   17055
   End
   Begin VB.Menu Menu 
      Caption         =   "Datei"
      Index           =   0
      Begin VB.Menu mnuDatei 
         Caption         =   "Diagramm zeichnen"
         Index           =   0
      End
      Begin VB.Menu mnuDatei 
         Caption         =   "Beenden"
         Index           =   1
      End
   End
   Begin VB.Menu Menu 
      Caption         =   "Ansicht"
      Index           =   1
      Begin VB.Menu mnuAnsicht 
         Caption         =   "Textfarbe"
         Index           =   0
      End
      Begin VB.Menu mnuAnsicht 
         Caption         =   "Linienfarbe"
         Index           =   1
      End
      Begin VB.Menu mnuAnsicht 
         Caption         =   "Koordinatensystemfarbe"
         Index           =   2
      End
      Begin VB.Menu mnuAnsicht 
         Caption         =   "Spaltenabstand"
         Index           =   3
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim WithEvents oDiag As clsLineDiagramm
Const mRand = 60

Private Sub Form_Load()
    
    Set oDiag = New clsLineDiagramm
    Set oDiag.Destination = picData
    
    With oDiag
        .Datum = CDate("02.01.2004 21:00:00") ' oder Now()  fr aktuelles EndDatum der Darstellung
        .TextColor = 0
        .ScaleColor = RGB(128, 128, 128)
        .LineColor = RGB(200, 100, 100)
        .FontName = "Tahoma"
        .FontSize = 7
        .Colwidth = 250
    End With
    
End Sub

Private Sub Form_Resize()
Static SkipFirst As Boolean

    If Me.WindowState = vbMinimized Then Exit Sub
    With sH
        .Left = mRand
        .Top = ScaleHeight - mRand - sH.Height
        .Width = ScaleWidth - (2 * mRand)
    End With
    
    With picContainer
        .Left = mRand
        .Top = mRand
        .Height = sH.Top - mRand
        .Width = sH.Width
    End With
    
    With picData
        .Left = mRand
        .Top = mRand
        .Height = picContainer.Height - (2 * mRand)
        If Not SkipFirst Then
            .Width = picContainer.Width - (2 * mRand)
        End If
    End With
    
    sH.Max = (picData.Width - sH.Width) + (2 * mRand)

    If SkipFirst Then oDiag.Draw
    SkipFirst = True
    
End Sub

Private Sub Form_Unload(Cancel As Integer)
    
    Set oDiag = Nothing
    
End Sub

Private Sub mnuAnsicht_Click(Index As Integer)
Dim shOpen As New clsCommonDialog
Dim w As Single

        Select Case Index
            Case 0
                With shOpen
                    .ShowColor
                    oDiag.TextColor = .Color
                End With
                
            Case 1
                With shOpen
                    .ShowColor
                    oDiag.LineColor = .Color
                End With
            
            Case 2
                With shOpen
                    .ShowColor
                    oDiag.ScaleColor = .Color
                End With
                            
            Case 3
                w = CSng(InputBox("Bitte neuen Spaltenabstand eingeben", "Spaltenabstnde", oDiag.Colwidth))
                oDiag.Colwidth = w
                
        End Select
    
    Set shOpen = Nothing
    
End Sub

Private Sub mnuDatei_Click(Index As Integer)
    
    Select Case Index
        Case 0
            oDiag.Draw
            
        Case 1:
            Unload Me
    End Select

End Sub

Private Sub oDiag_Drawed()

    sH.Max = (picData.Width - sH.Width) + (2 * mRand)
    sH.Value = 0
    
End Sub

Private Sub oDiag_NoData()
    MsgBox "Keine Daten gefunden!"
    With picData
        .Cls
        .Left = mRand
        .Top = mRand
        .Height = picContainer.Height - (2 * mRand)
        .Width = picContainer.Width - (2 * mRand)
    End With

End Sub

Private Sub sH_Change()
    
    picData.Left = (sH.Left) - sH.Value
    picContainer.SetFocus
    
End Sub
