VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "Liniendiagramm fr 24h  Michael Kunz"
   ClientHeight    =   7335
   ClientLeft      =   60
   ClientTop       =   240
   ClientWidth     =   11655
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   489
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   777
   StartUpPosition =   3  'Windows-Standard
   WindowState     =   2  'Maximiert
   Begin VB.Frame frame 
      Height          =   7215
      Left            =   8880
      TabIndex        =   1
      Top             =   0
      Width           =   2655
      Begin VB.CommandButton butAddScale 
         Caption         =   "+"
         Height          =   255
         Left            =   2280
         TabIndex        =   12
         Top             =   2520
         Width           =   255
      End
      Begin VB.CommandButton butSubScale 
         Caption         =   "-"
         Height          =   255
         Left            =   1440
         TabIndex        =   11
         Top             =   2520
         Width           =   255
      End
      Begin VB.CheckBox chkFreeScale 
         Caption         =   "freie Skale"
         Height          =   255
         Left            =   240
         TabIndex        =   10
         Top             =   2160
         Width           =   1095
      End
      Begin VB.TextBox txtDatenpfad 
         Height          =   285
         Left            =   240
         TabIndex        =   6
         Top             =   360
         Width           =   2295
      End
      Begin VB.CommandButton butZeichnen 
         Caption         =   "Zeichnen"
         Default         =   -1  'True
         Height          =   615
         Left            =   1440
         TabIndex        =   5
         Top             =   1440
         Width           =   1095
      End
      Begin VB.CommandButton butEnde 
         Cancel          =   -1  'True
         Caption         =   "Ende"
         Height          =   615
         Left            =   1440
         TabIndex        =   4
         Top             =   6480
         Width           =   1095
      End
      Begin VB.TextBox txtVerwendet 
         Height          =   285
         Left            =   240
         TabIndex        =   3
         Top             =   960
         Width           =   2295
      End
      Begin VB.TextBox txtFreeScale 
         Height          =   285
         Left            =   1440
         TabIndex        =   2
         Text            =   "1"
         Top             =   2160
         Width           =   1095
      End
      Begin VB.Label labDatenPfad 
         AutoSize        =   -1  'True
         BackStyle       =   0  'Transparent
         Caption         =   "Datenpfad:"
         Height          =   195
         Left            =   120
         TabIndex        =   9
         Top             =   120
         Width           =   795
      End
      Begin VB.Label labNOW 
         Height          =   375
         Left            =   240
         TabIndex        =   8
         Top             =   1560
         Width           =   1095
      End
      Begin VB.Label labVerwendet 
         AutoSize        =   -1  'True
         BackStyle       =   0  'Transparent
         Caption         =   "Verwendete Dateien:"
         Height          =   195
         Left            =   120
         TabIndex        =   7
         Top             =   720
         Width           =   1500
      End
   End
   Begin Project.usrCoords usrCoord 
      Height          =   7215
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   8655
      _extentx        =   15478
      _extenty        =   12726
      graphfarbe      =   255
      y_scale         =   0.1
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit     'Ale Variablen mssen deklariert werden

Private Const cDatenPath As String = "%app.path%\Daten\"    'Ordner, in dem die Daten gespeichert sind,
                                                            'kann nach belieben gendert werden
                                                            '%app.path% entspricht <App.Path>

Private Type DatenTyp   'Datentyp zur Zwischenspeicherung der Daten
    Zeit As Date        'Zeit des Datensatzes (mit Tag und Uhrzeit)
    Value As Double     'Wert des Datensatzes
End Type

Private Sub butAddScale_Click()
    Dim str As String                               'allg. String-Variable
    Dim V As Double                                 'Wert der neuen Achseneinteilung
    Screen.MousePointer = vbHourglass               'setze Mauszeiger auf Sanduhr
    str = CStr(Round(Abs(Val(txtFreeScale.Text))))  'str soll die Ziffern vorm Komma der Eingabe im Textfeld txtFreeScale zugewiesen bekommen
    V = 0.2 * Val(Left(str, 1)) * 10 ^ (Len(str))   'v ist der neue Wert; rund das Doppelte (0.1 entspricht 100%)
    txtFreeScale.Text = CStr(V)                     'Ausgabe im Textfeld
    usrCoord.Y_Scale = V                            'Zuweisung ans Koordinatensystem
    Call usrCoord.MakeCoords(False)                 'Koordinatensystem mit manueller Skalierung neu Zeichnen
    Screen.MousePointer = vbDefault                 'Mauszeiger zurcksetzen
End Sub

Private Sub butEnde_Click()
    Unload Me   'sauber beenden
End Sub

Private Sub butSubScale_Click()
    Dim str As String                               'allg. String-Variable
    Dim V As Double                                 'Wert der neuen Achseneinteilung
    Screen.MousePointer = vbHourglass               'setze Mauszeiger auf Sanduhr
    str = CStr(Round(Abs(Val(txtFreeScale.Text))))  'str soll die Ziffern vorm Komma der Eingabe im Textfeld txtFreeScale zugewiesen bekommen
    V = 0.05 * Val(Left(str, 1)) * 10 ^ (Len(str))  'v ist der neue Wert; rund die Hlfte (0.1 entspricht 100%)
    txtFreeScale.Text = CStr(V)                     'Ausgabe im Textfeld
    usrCoord.Y_Scale = V                            'Zuweisung ans Koordinatensystem
    Call usrCoord.MakeCoords(False)                 'Koordinatensystem mit manueller Skalierung neu Zeichnen
    Screen.MousePointer = vbDefault                 'Mauszeiger zurcksetzen
End Sub

Private Sub butZeichnen_Click()
    Const ForReading = 1                'Konstante fr Dateizugriffsparameter
    Dim Daten() As DatenTyp             'Array zum Zwischenlagern der Datenstze
    Dim UpperRange As Long              'Zhlvariable fr Obergrenze des Arrays
    Dim FileNames(0 To 1) As String     'Array fr die beiden Dateinamen, der bentigten Dateien
    Dim Jetzt As Date                   'Variable zum Zwischenspeichern der Uhrzeit
    Dim i As Long                       'Schleifenvariable
    Dim FSO As Object                   'FileSystemObject
    Dim TS As Object                    'TextStreamObject zum Auslesen aus der Datei
    Dim FileDate As Date                'Datum in der Datei
    Dim str As String                   'allg. Stringvariable
    Dim Zeit As Date                    'Uhrzeit des aktuellen Datensatzes
    Dim PeakValue As Double             'Maximalwert der Datenstze
    
    Screen.MousePointer = vbHourglass           'setze Mauszeiger auf Sanduhr
    Jetzt = Now                                 'Zuweisen der Uhrzeit
    labNOW.Caption = CStr(Jetzt)                'Ausgabe der Uhrzeit im Label (nur Info)
    txtVerwendet.Text = Format(Date, "yyyymmdd") & ".txt   " & Format(Date - 1, "yyyymmdd") & ".txt"
                                                'Ausgabe der beiden Dateinamen (nur Info)
                                                
    FileNames(0) = txtDatenpfad.Text & Format(Jetzt - 1, "yyyymmdd") & ".txt"
                                                '1. Dateiname bilden (Vortag)
                                                
    FileNames(1) = txtDatenpfad.Text & Format(Jetzt, "yyyymmdd") & ".txt"
                                                '2. Dateiname bilden (heute)
                                                
    Set FSO = CreateObject("Scripting.FileSystemObject")
                                                'Erzeugen der Variable fr DateiSystemZugriff
                                                
    ReDim Daten(0 To 0) As DatenTyp             'Datenarray initialisieren (sonst treten Probleme mit dem Preserve auf)
    UpperRange = -1                             'UpperRange initialisieren
    For i = 0 To 1                              'Schleife fr die einzelnen Dateien
        If FSO.FileExists(FileNames(i)) Then    'Dateioperationen nur durchfhren, wenn sie existiert
            Set TS = FSO.OpenTextFile(FileNames(i), ForReading)
                                                'ffnen der Datei
                                                
            FileDate = CDate(TS.readline)       'Auslesen des Datums aus der Datei
            Call TS.readline                    'berspringen der Leerzeile
            
            While Not TS.AtEndOfStream          'Datei bis zum Ende einlesen
                str = TS.readline               'eine Zeile/Datensatz einlesen
                Zeit = FileDate + CDate(Left(str, InStr(1, str, " ") - 1))
                                                'Uhrzeit auslesen und mit Datum ergnzen
                                                
                If (Jetzt - Zeit <= 1) And (Zeit <= Jetzt) Then
                                                'Datensatz nur aufnehmen,
                                                'wenn er nicht lter als einen Tag
                                                'und nicht neuer ist, als es jetzt ist (vor allem fr die Testdateien ntig)
                                                
                    UpperRange = UpperRange + 1 'Datensatz weiterzhlen
                    ReDim Preserve Daten(0 To UpperRange) As DatenTyp
                                                'Array vergrern, um neuen Datensatz aufzunehmen (mit Preserve alte Eintrge beibehalten)
                                                
                    Daten(UpperRange).Zeit = Zeit
                    Daten(UpperRange).Value = Val(Mid(str, InStr(1, str, " ") + 1))
                                                'Zuweisung des Datensatzes ans Array
                                                
                End If 'If (Jetzt - Zeit <= 1) And (Zeit <= Jetzt) Then
            Wend 'While Not TS.AtEndOfStream
            
            Call TS.Close                       'Datei schlieen
        End If 'FileExists
    Next i
    
    usrCoord.ClearGraph                         'alten Graph lschen
    
    PeakValue = 0                               'auf 0 initialisieren
    For i = 0 To UpperRange                     'alle Datenstze durchlaufen, und grten Wert suchen
        If Daten(i).Value > PeakValue Then PeakValue = Daten(i).Value
                        'Falls der Wert des aktuellen Wertes grer als jeder bisherige Wert ist, PeakValue neu Zuweisen
    Next i
    
    usrCoord.Y_Max = 1.05 * PeakValue           'neues Maximum zuweisen (1.05 *, um noch etwas vergrern, um nach oben noch 5% Freiraum zu haben; nur optisches Detail)
    If (chkFreeScale.Value = vbChecked) Then usrCoord.Y_Scale = Val(txtFreeScale.Text)
                                                'Falls in Checkbox gewhlt, manuellen Skalierungswert setzen
                                                
    Call usrCoord.MakeCoords(chkFreeScale.Value = vbUnchecked)
                                                'Koordinatensystem zeichnen
    For i = 1 To UpperRange                     'alle Datenstze durchlaufen und zeichnen
    
        If Daten(i).Zeit - Daten(i - 1).Zeit < CDate("00:20:00") Then
                                                'nur benachbarte (weniger als 20 Minuten auseinander liegende) Datenstze zeichnen
                                                
            Call usrCoord.DrawLine(Jetzt - Daten(i - 1).Zeit, Daten(i - 1).Value, Jetzt - Daten(i).Zeit, Daten(i).Value)
                                                'Linie zeichnen
                                                
        End If
    Next i
    
    Screen.MousePointer = vbDefault             'Mauszeiger zurcksetzen
End Sub

Private Sub Form_Load()
    'Wertet die Konstante cDatenPath aus und zeigt das Ergebnis an
    txtDatenpfad.Text = Replace(Replace(cDatenPath, "%app.path%", App.Path, , , vbTextCompare), "\\", "\")
End Sub

Private Sub Form_Resize()
    'Controls neu anordnen
    Call usrCoord.Move(6, 6, Abs(Me.ScaleWidth - frame.Width - 18), Abs(Me.ScaleHeight - 12))
    Call frame.Move(Me.ScaleWidth - frame.Width - 6, 2, frame.Width, Me.ScaleHeight - 10)
    Call butEnde.Move(Me.ScaleY(frame.Width - 6, Me.ScaleMode, vbTwips) - butEnde.Width, Me.ScaleY(frame.Height - 6, Me.ScaleMode, vbTwips) - butEnde.Height)
    Call usrCoord.ClearGraph
End Sub

