VERSION 5.00
Begin VB.UserControl usrCoords 
   AutoRedraw      =   -1  'True
   BackColor       =   &H00000000&
   BorderStyle     =   1  'Fest Einfach
   ClientHeight    =   5790
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   7410
   ForeColor       =   &H00FFFF00&
   ScaleHeight     =   386
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   494
   Begin VB.Timer timerHide 
      Enabled         =   0   'False
      Interval        =   100
      Left            =   120
      Top             =   120
   End
   Begin VB.TextBox txtValue 
      Alignment       =   1  'Rechts
      BackColor       =   &H00000000&
      BorderStyle     =   0  'Kein
      ForeColor       =   &H00FFFF00&
      Height          =   195
      Left            =   5640
      Locked          =   -1  'True
      TabIndex        =   3
      Top             =   0
      Visible         =   0   'False
      Width           =   1215
   End
   Begin VB.PictureBox pic 
      BackColor       =   &H00000000&
      BorderStyle     =   0  'Kein
      ForeColor       =   &H00FFFF00&
      Height          =   2655
      Left            =   1680
      ScaleHeight     =   177
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   345
      TabIndex        =   2
      Top             =   360
      Width           =   5175
      Begin VB.Line KreuzV 
         BorderColor     =   &H00FFFF00&
         Visible         =   0   'False
         X1              =   248
         X2              =   248
         Y1              =   16
         Y2              =   112
      End
      Begin VB.Line KreuzH 
         BorderColor     =   &H00FFFF00&
         Visible         =   0   'False
         X1              =   216
         X2              =   304
         Y1              =   88
         Y2              =   88
      End
      Begin VB.Line lineGraph 
         BorderColor     =   &H000000FF&
         Index           =   0
         Visible         =   0   'False
         X1              =   128
         X2              =   176
         Y1              =   72
         Y2              =   56
      End
      Begin VB.Line lineV 
         BorderColor     =   &H00FFFF00&
         Index           =   0
         X1              =   0
         X2              =   0
         Y1              =   0
         Y2              =   136
      End
      Begin VB.Line lineH 
         BorderColor     =   &H00FFFF00&
         Index           =   0
         X1              =   8
         X2              =   152
         Y1              =   144
         Y2              =   144
      End
   End
   Begin VB.Label labH 
      Alignment       =   1  'Rechts
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "0"
      ForeColor       =   &H00FFFF00&
      Height          =   195
      Index           =   0
      Left            =   1200
      TabIndex        =   1
      Top             =   2760
      Width           =   90
   End
   Begin VB.Label labV 
      Alignment       =   1  'Rechts
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "0"
      ForeColor       =   &H00FFFF00&
      Height          =   195
      Index           =   0
      Left            =   765
      TabIndex        =   0
      Top             =   2160
      Width           =   90
   End
End
Attribute VB_Name = "usrCoords"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'Variablen zum speichern der Eigenschaften
Private m_Y_Max As Double               'Maximum der Y-Achse
Private m_BackColor As OLE_COLOR        'Hintergrundfarbe
Private m_AxenFarbe As OLE_COLOR        'Farbe der Achsen und des Fadenkreuzes
Private m_HilfslinienFarbe As OLE_COLOR 'Farbe der Hilfslinien
Private m_GraphFarbe As OLE_COLOR       'Farbe des Graphs
Private m_Y_Scale As Double             'Achseneinteilung

Private Type POINTAPI   'Punkt fr API's
    X As Long
    Y As Long
End Type
'API's um das Fadenkreuz richtig zu Entfernen
Private Declare Function GetCursorPos Lib "user32.dll" (lpPoint As POINTAPI) As Long
Private Declare Function WindowFromPoint Lib "user32.dll" (ByVal xPoint As Long, ByVal yPoint As Long) As Long

Public Property Get Y_Max() As Double 'Maximum der Y-Achse
    Y_Max = m_Y_Max
End Property
Public Property Let Y_Max(Y As Double) 'Maximum der Y-Achse
    m_Y_Max = Y
    pic.ScaleTop = m_Y_Max
    pic.ScaleHeight = -m_Y_Max
End Property

Public Property Get BackColor() As OLE_COLOR 'Hintergrundfarbe
    BackColor = m_BackColor
End Property
Public Property Let BackColor(c As OLE_COLOR) 'Hintergrundfarbe
    m_BackColor = c
    UserControl.BackColor = c
    pic.BackColor = c
End Property

Public Property Get AxenFarbe() As OLE_COLOR 'Farbe der Achsen und des Fadenkreuzes
    AxenFarbe = m_AxenFarbe
End Property
Public Property Let AxenFarbe(c As OLE_COLOR) 'Farbe der Achsen und des Fadenkreuzes
    Dim lab As Label
    m_AxenFarbe = c
    lineH(0).BorderColor = c
    lineV(0).BorderColor = c
    txtValue.ForeColor = c
    For Each lab In labH 'alle Labels neu Frben
        lab.ForeColor = c
    Next lab
    For Each lab In labV 'alle Labels neu Frben
        lab.ForeColor = c
    Next lab
End Property

Public Property Get HilfslinienFarbe() As OLE_COLOR 'Farbe der Hilfslinien
    HilfslinienFarbe = m_HilfslinienFarbe
End Property
Public Property Let HilfslinienFarbe(c As OLE_COLOR) 'Farbe der Hilfslinien
    Dim l As Line
    m_HilfslinienFarbe = c
    For Each l In lineH 'alle Linien neu Frben
        If l.Index > 0 Then l.BorderColor = c
    Next l
    For Each l In lineV 'alle Linien neu Frben
        If l.Index > 0 Then l.BorderColor = c
    Next l
End Property

Public Property Get GraphFarbe() As OLE_COLOR 'Farbe des Graphs
    GraphFarbe = m_GraphFarbe
End Property
Public Property Let GraphFarbe(c As OLE_COLOR) 'Farbe des Graphs
    Dim l As Line
    m_GraphFarbe = c
    For Each l In lineGraph 'alle Linien neu Frben
        l.BorderColor = c
    Next l
End Property

Public Property Get Y_Scale() As Double 'Achseneinteilung
    Y_Scale = m_Y_Scale
End Property
Public Property Let Y_Scale(S As Double) 'Achseneinteilung
    m_Y_Scale = S
End Property

'Zeichnet das Koordinatensystem
'UseAutoScale gibt an, ob die Achseneinteilung automatisch vorgenommen werden soll,
                     'oder sich nach m_Y_Scale richtet
Public Sub MakeCoords(Optional UseAutoScale As Boolean = True)
    Const cStandartScalenTeile = 10     'Anzahl der Hilfslinien auf der Y-Achse

    Dim i As Long                       'allg. Schleifenvariable
    Dim str As String                   'allg. Stringvariable
    Dim LinesNeeded As Long             'Anzahl der bentigten Linien entlang der Y-Achse
    If lineH.Count < 13 Then            'falls noch nicht alle bentigten Linien entlang der X-Achse existieren
        For i = 1 To 12                 '...neue erzeugen
            Load lineH(i)               'linie erzeugen
            lineH(i).BorderColor = m_HilfslinienFarbe
                                        'Linienfarbe zuweisen
            lineH(i).Visible = True     'linie anzeigen
            Load labH(i)                'Linienbeschriftungslabel erzeugen
            labH(i).ForeColor = m_AxenFarbe
                                        'Textfarbe zuweisen
            labH(i).Visible = True      'Label anzeigen
        Next i
    End If 'If lineH.Count < 13 Then
    
    If UseAutoScale Then                'Falls die Achse automatisch unterteilt werden soll
        str = CStr(Round(Abs(pic.ScaleHeight)))
                                        'str soll die Ziffern vorm Komma der Hhe des Koordinatensystems enthalten
        m_Y_Scale = 0.1 / cStandartScalenTeile * Val(Left(str, 1)) * 10 ^ (Len(str))
                                        'errechnen der Achseneinteilung
    End If
    
    If m_Y_Scale = 0 Then m_Y_Scale = 1 'um Fehler (Division durch NULL) zu vermeiden
    
    LinesNeeded = Round(Abs(pic.ScaleHeight) / m_Y_Scale + 1)
                                        'Berechne die Anzahl der bentigten Linien entlang der Y-Achse
    
    If lineV.Count < LinesNeeded Then   'Falls nicht genug Linien vorhanden sind
                                        'genug neue erzeugen und Farben zuweisen
        For i = lineV.ubound + 1 To LinesNeeded - 1
            Load lineV(i)
            lineV(i).BorderColor = m_HilfslinienFarbe
            Load labV(i)
            labV(i).ForeColor = m_AxenFarbe
        Next i
    ElseIf lineV.Count > LinesNeeded Then 'Falls zuviele Linien vorhanden sind,
                                        'die berflssigen entladen
        For i = LinesNeeded To lineV.ubound
            Unload lineV(i)
            Unload labV(i)
        Next i
    End If
    
    For i = 0 To lineV.ubound   'die Linien entlang der Y-Achse anordnen, anzeigen und die Labels beschriften & anzeigen
        lineV(i).X1 = pic.ScaleLeft
        lineV(i).X2 = pic.ScaleLeft + pic.ScaleWidth
        lineV(i).Y1 = i * m_Y_Scale - pic.ScaleY(1, vbPixels, pic.ScaleMode)
        lineV(i).Y2 = lineV(i).Y1
        lineV(i).Visible = True
        labV(i).Caption = CStr(i * m_Y_Scale)
        Call labV(i).Move(48 - labV(i).Width, 2 + pic.Top + pic.Height - labV(i).Height + pic.ScaleY(lineV(i).Y1, pic.ScaleMode, vbPixels))
        labV(i).Visible = True
    Next i
    
    For i = 0 To lineH.ubound   'die Linien entlang der X-Achse anordnen und die Labels beschriften
        lineH(i).X1 = pic.ScaleLeft + pic.ScaleWidth / 12 * i
        lineH(i).X2 = lineH(i).X1
        lineH(i).Y1 = pic.ScaleTop
        lineH(i).Y2 = pic.ScaleTop + pic.ScaleHeight
        
        labH(i).Caption = CStr(-2 * i) & "h"
        Call labH(i).Move(pic.Left + pic.ScaleX(lineH(i).X1, pic.ScaleMode, UserControl.ScaleMode), pic.Top + pic.Height + 1)
    Next i
End Sub

'lscht den aktuell gezeichneten Graph, indem es alle Lineobjekte auer das erste entld
Public Sub ClearGraph()
    Dim l As Line
    For Each l In lineGraph
        If l.Index > 0 Then
            Unload l
        Else
            l.Visible = False
        End If
    Next l
End Sub
'Zeichnet einen Abschnitt des Graphs zwischen den angegebenen Koordinaten
Public Sub DrawLine(X1 As Double, Y1 As Double, X2 As Double, Y2 As Double)
    Dim l As Line
    Load lineGraph(lineGraph.Count)     'erzeugt den neuen Abschnitt
    Set l = lineGraph(lineGraph.ubound)
    l.BorderColor = m_GraphFarbe        'Farbe zuweisen
    l.X1 = X1                           'an Position setzen
    l.X2 = X2
    l.Y1 = Y1
    l.Y2 = Y2
    l.Visible = True                    'anzeigen
    l.ZOrder 0                          'ganz vorn/oben plazieren (damit es nicht unter den Hilfslinien verschwindet)
    Set l = Nothing
End Sub




Private Sub pic_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
'zeigt ein Fadenkreuz zum Vergleich und die Koordinate an
    'Koordinaten ausgeben:
    txtValue.Text = "( -" & CStr(CDate(X)) & "; " & CStr(Y) & " )"
    txtValue.Width = UserControl.TextWidth(txtValue.Text)
    txtValue.BackColor = m_BackColor
    txtValue.ForeColor = m_AxenFarbe
    'Fadenkreuz ausrichten:
    KreuzH.X1 = pic.ScaleLeft
    KreuzH.X2 = pic.ScaleLeft + pic.ScaleWidth
    KreuzH.Y1 = Y
    KreuzH.Y2 = Y
    KreuzV.X1 = X
    KreuzV.X2 = X
    KreuzV.Y1 = pic.ScaleTop
    KreuzV.Y2 = pic.ScaleTop + pic.ScaleHeight
    KreuzH.BorderColor = m_AxenFarbe
    KreuzV.BorderColor = m_AxenFarbe
    
    'alles anzeigen:
    txtValue.Visible = True
    KreuzH.Visible = True
    KreuzV.Visible = True
    
    'timer starten, der das Fadenkreuz wieder versteckt, wenn man mit der Maus das Koordinatensystem verlsst
    timerHide.Enabled = True
End Sub

Private Sub pic_Resize()
    'inneres Koordinatensystem wieder festlegen und neu zeichnen
    pic.Scale (0, m_Y_Max)-(1, 0)
    Call Me.MakeCoords
End Sub

Private Sub timerHide_Timer()   'wird ausgefhrt, wenn sich die Maus ber das Koordinatensystem bewegt hat
    Dim c As POINTAPI
    Call GetCursorPos(c)        'liest die Mausposition auf dem Bildschirm aus
    'Falls das Fenster, ber dem sich die Maus befindet, nicht unser Koordinatensystem ist,
        'wird das Fadenkreuz ausgeblendet
    If pic.hWnd <> WindowFromPoint(c.X, c.Y) Then
        KreuzH.Visible = False
        KreuzV.Visible = False
        timerHide.Enabled = False
    End If
End Sub

Private Sub txtValue_Change()
    'wenn sich der Text ndert, der TextBox die richtige Gre und Position zuweisen
    Call txtValue.Move(UserControl.ScaleWidth - txtValue.Width - 2, 1, UserControl.TextWidth(txtValue.Text))
End Sub

Private Sub UserControl_Initialize()
    m_Y_Max = 1 'sonst gibt es Fehler
End Sub

Private Sub UserControl_InitProperties()
    'beim Erzeugen des Controls die Eigenschaften neu initialisieren
    m_BackColor = vbBlack
    m_AxenFarbe = vbCyan
    m_HilfslinienFarbe = RGB(0, 128, 128)
    m_GraphFarbe = vbRed
    m_Y_Scale = 100
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    'Properties laden
    m_BackColor = PropBag.ReadProperty("BackColor", vbBlack)
    m_AxenFarbe = PropBag.ReadProperty("AxenFarbe", vbCyan)
    m_HilfslinienFarbe = PropBag.ReadProperty("HilfslinienFarbe", RGB(0, 128, 128))
    m_GraphFarbe = PropBag.ReadProperty("GraphFarbe", vbBlack)
    m_Y_Scale = PropBag.ReadProperty("Y_Scale", 100)
End Sub

Private Sub UserControl_Resize()
    'Controls neu ausrichten
    Call pic.Move(50, 15, Abs(UserControl.ScaleWidth - 72), Abs(UserControl.ScaleHeight - 30))
    Call txtValue.Move(UserControl.ScaleWidth - txtValue.Width - 2, 1, UserControl.TextWidth(txtValue.Text))
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    'Properties speichern
    Call PropBag.WriteProperty("BackColor", m_BackColor, vbBlack)
    Call PropBag.WriteProperty("AxenFarbe", m_AxenFarbe, vbCyan)
    Call PropBag.WriteProperty("HilfslinienFarbe", m_HilfslinienFarbe, RGB(0, 128, 128))
    Call PropBag.WriteProperty("GraphFarbe", m_GraphFarbe, vbBlack)
    Call PropBag.WriteProperty("Y_Scale", m_Y_Scale, 100)
End Sub
